import { tidyStr } from '/helpers.js'

export const controls = (selection, props) => {
  const { 
    dataColumns,
    columns,
    render,
    showAllNodes,
    setAllNodes
  } = props
  
  const row1 = selection.select('#row1')
  const row2 = selection.select('#row2')
 
  Object.keys(columns).forEach(column => {
    const container = row1.selectAll('.col-' + column).data([null])
    const contEnter = container.enter().append('div')
    	.attr('class', 'ctrl-g col-' + column)
    contEnter.append('div').attr('class', 'col-label')
    	.text('Column ' + column.toUpperCase())
    contEnter.merge(container)
	    .selectAll('.column-key').data(dataColumns)
  	  	.enter().append('div')
    			.attr('class', 'column-key')
    		.merge(container.selectAll('.column-key'))
	    		.text(d => tidyStr(d))
  	    	.attr('class', d => {
    	    	const extent = columns[column] === d
      	  		? ' selected'
        			: ''
	      		return 'column-key' + extent
  				})
    	    .on('click', d => {
      	    columns[column] = d
    				render();
        	})
  })
  
  const filterContainer = row1.selectAll('.filter-container').data([null])
  const filterEnter = filterContainer.enter().append('div')
    .attr('class', 'filter-container')
  filterEnter.append('p')
  	.text('Showing ')
  	.append('span')
  		.attr('id', 'max-display')
  		.merge(filterContainer.select('#max-display'))
  		.text(() => {
    			return showAllNodes
           ? 'all ships'
           : 'small ships'
  		})
  filterEnter.append('input')
  	.attr('class', 'checkbox')
  	.attr('type', 'checkbox')
  	.attr('id', 'all-ships-toggle')
  	.on('change', function() {
    	setAllNodes(this.checked)
    	render()
  	})
  filterEnter.append('label')
  	.attr('for', 'all-ships-toggle')
  	.text('Show all ships')		
}